////////////////////////////////////////////////////////////////////
// 
// Copyright (C) Decision Computer International Co., Ltd 
//
// # Project Name: PCI 8255/8254 Card VC++ 6.0 Sample (Dii)
//
// # Used Library: Dynamice Industrial Interface (DII)
//
// # Revised: WeiCheng, Tu          2005/06/18
//			@ implement to DII version
//
////////////////////////////////////////////////////////////////////

// TestDeviceLibDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestDeviceLib.h"
#include "TestDeviceLibDlg.h"
#include "Dii.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDeviceLibDlg dialog

CTestDeviceLibDlg::CTestDeviceLibDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDeviceLibDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDeviceLibDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDeviceLibDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDeviceLibDlg)
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDCANCEL, m_Cancel);
	DDX_Control(pDX, IDC_BUTTON5, m_Display8254);
	DDX_Control(pDX, IDC_BUTTON4, m_Test8254);
	DDX_Control(pDX, IDC_BUTTON1, m_Test8255LoopBack);
	DDX_Control(pDX, IDC_BUTTON3, m_Status);
	DDX_Control(pDX, IDC_BUTTON2, m_Display);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestDeviceLibDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDeviceLibDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDeviceLibDlg message handlers

BOOL CTestDeviceLibDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//
	// select device
	//
    char szDeviceName[101];
	if (!DiiSelectDevice(NULL, szDeviceName,100))
	{
		AfxMessageBox ("Get device name Error!");
		return FALSE;
	}

	//
	// open user choosen device
	//
	hDevice = DiiOpenNamedDevice (szDeviceName, TRUE);
	if (hDevice ==INVALID_HANDLE_VALUE)
	{
		AfxMessageBox ("Open device Error!");
		return FALSE;
	}

	//
	// some initializations
	//
	m_nTimer = SetTimer (1, 1000, 0);
	m_bTest8255 = FALSE;
	m_bTest8254 = FALSE;
	bInitial = FALSE;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestDeviceLibDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDeviceLibDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDeviceLibDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//
// test 8255 loopback function
//
void CTestDeviceLibDlg::test8255loopback()
{
    int i;
    static unsigned int loop = 0;
    unsigned long x;            // 1st 8255 chip (contains three ports)
    unsigned char x1, x2, x3;   // three ports for 1st 8255 chip
    unsigned long y;            // correct input value (checked data)
    unsigned char y1, y2, y3;   // correct input value (checked data)
    unsigned char z1, z2, z3;   // three ports for 2nd 8255 chip 
    CString str;

    //
    // 8255 port configuration
    //
	DiiSet8255Config (hDevice, 0, 0x80);
	DiiSet8255Config (hDevice, 1, 0x9b);

	// note..
	//   DII interface hide config port, so 1st 8255chip has port 0~2, 2nd 8255chip
	//   has port 3~5, etc. (see remark part of these I/O functions on DII manual for detail)

    //
    // loopback operations
    //
    for (i = 0; i < 24; i++) 
	{
		x = (unsigned long)1 << i;
		x1 = (unsigned char)(x & 0x00ff);
		x2 = (unsigned char)((x >> 8) & 0x00ff);
		x3 = (unsigned char)((x >> 16) & 0x00ff);
		y = 0x00800000 >> i;
		y1 = (unsigned char)(y & 0x00ff);
		y2 = (unsigned char)((y >> 8) & 0x00ff);
		y3 = (unsigned char)((y >> 16) & 0x00ff);
		DiiSetDigitalByte (hDevice, 0, x1);
		DiiSetDigitalByte (hDevice, 1, x2);
		DiiSetDigitalByte (hDevice, 2, x3);

		// delay
		for (int a=0; a <= 2000; a++)
			for (int b=0; b<= 2000; b++); 

		DiiGetDigitalByte (hDevice, 3, &z1);
		DiiGetDigitalByte (hDevice, 4, &z2);
		DiiGetDigitalByte (hDevice, 5, &z3);
		str.Format("Loop: %3d  Testing Pin:%2d  Output: %02X%02X%02X  Input:%02X%02X%02X  Correct:%02X%02X%02X",
	       loop + 1, i, x3, x2, x1, z3, z2, z1, y3, y2, y1);

		m_Display.SetWindowText(str);

		if (z1 != y1 || z2 != y2 || z3 != y3) 
			m_Status.SetWindowText("Test Result : Error");
		else 
			m_Status.SetWindowText("Test Result : OK");
	}

	loop++;
	if(loop > 1000)
		loop = 0;
}

void CTestDeviceLibDlg::OnButton1() 
{
	m_bTest8255 = !m_bTest8255;

	if(m_bTest8255)
		m_Test8255LoopBack.SetWindowText("Stop Test 8255 Loopback");
	else
		m_Test8255LoopBack.SetWindowText("Start Test 8255 Loopback");
}


void CTestDeviceLibDlg::test8254()
{
	static unsigned long loop = 0L;
	unsigned long cnt0 = 0, cnt1 = 0, cnt2 = 0;   // counter value
	CString str; 

	//
	// initialization (for first time)
	//
	if(bInitial == FALSE)
	{
		DiiSetTimerConfig (hDevice, 0, 0x30);  // Counter 0: Mode 0, LSB + MSB
		DiiLoadTimer (hDevice, 0, 1000);

		DiiSetTimerConfig (hDevice, 1, 0x70);  // Counter 1: Mode 0, LSB + MSB
		DiiLoadTimer (hDevice, 1, 1000);

		DiiSetTimerConfig (hDevice, 2, 0xb0);  // Counter 2: Mode 0, LSB + MSB
		DiiLoadTimer (hDevice, 2, 1000);

		bInitial = TRUE;
	}

	//
	// get counter value
	//
	DiiGetTimer (hDevice, 0, &cnt0);
	DiiGetTimer (hDevice, 1, &cnt1);
	DiiGetTimer (hDevice, 2, &cnt2);

	str.Format("Loop: %8ld : counter: %6u %6u %6u", loop, cnt0, cnt1, cnt2);
	m_Display8254.SetWindowText(str);
	
	 loop++;
	 if(loop > 1000)
			loop = 0;

}

void CTestDeviceLibDlg::OnButton4() 
{
	m_bTest8254 = !m_bTest8254;

	if(m_bTest8254)
		m_Test8254.SetWindowText("Stop Test 8254 Loopback");
	else
		m_Test8254.SetWindowText("Start Test 8254 Loopback");
}

void CTestDeviceLibDlg::OnTimer(UINT nIDEvent)
{
	if(m_bTest8255)
		test8255loopback();

	if(m_bTest8254)
		test8254();
	
	CDialog::OnTimer(nIDEvent);
}

void CTestDeviceLibDlg::OnOK() 
{
	KillTimer(m_nTimer);   
    DiiCloseDevice(hDevice);	
	CDialog::OnOK();
}

void CTestDeviceLibDlg::OnCancel() 
{
	KillTimer(m_nTimer);   
    DiiCloseDevice(hDevice);	
	CDialog::OnCancel();
}

