////////////////////////////////////////////////////////////////////
// 
// Copyright (C) Decision Computer International Co., Ltd 
//
// # Project Name: PCI Multiple 8255/8254 Card
//                      VC++ 6.0 Sample (DII)
//
// # Used Library: Dynamice Industrial Interface
//
// # Revised: WeiCheng, Tu          2005/06/18
//       @ implement to DII version
//
////////////////////////////////////////////////////////////////////

// TestDeviceLibDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestDeviceLib.h"
#include "TestDeviceLibDlg.h"
#include "Dii.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDeviceLibDlg dialog

CTestDeviceLibDlg::CTestDeviceLibDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDeviceLibDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDeviceLibDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDeviceLibDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDeviceLibDlg)
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDCANCEL, m_Cancel);
	DDX_Control(pDX, IDC_BUTTON5, m_Display8254);
	DDX_Control(pDX, IDC_BUTTON4, m_Test8254);
	DDX_Control(pDX, IDC_BUTTON1, m_Test8255LoopBack);
	DDX_Control(pDX, IDC_BUTTON3, m_Status);
	DDX_Control(pDX, IDC_BUTTON2, m_Display);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestDeviceLibDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDeviceLibDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDeviceLibDlg message handlers

BOOL CTestDeviceLibDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//
	// select device
	//
    char szDeviceName[101];
	if (!DiiSelectDevice(NULL, szDeviceName,100))
	{
		AfxMessageBox ("Get device name Error!");
		return FALSE;
	}

	//
	// open user choosen device
	//
	hDevice = DiiOpenNamedDevice (szDeviceName, TRUE);
	if (hDevice ==INVALID_HANDLE_VALUE)
	{
		AfxMessageBox ("Open device Error!");
		return FALSE;
	}

	//
	// some initializations
	//
	m_nTimer = SetTimer(1, 100, 0);
	m_bTest8255 = FALSE;
	m_bTest8254 = FALSE;
	bInitial = FALSE;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestDeviceLibDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDeviceLibDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDeviceLibDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// this function just for demo UI display
void CTestDeviceLibDlg::mydelay(void)
{
	int i,j, k = 0;
	for( i =0; i < 3000; i++)
		for( j =0; j < 3000; j++);
			k *= (i*j);
}

void CTestDeviceLibDlg::test8255loopback()
{
	int  i;
	int grp;                   // 8255 chip # (1~4: output, 5~8: input)
	int ofs;				   // port offset
    static unsigned int loop = 0;
	unsigned long x;           // output value
	unsigned char x1, x2, x3;  // three output port values
	unsigned char y1, y2, y3;  // three input port values
	CString str;

	//
	// 8255 port configuration
	//
	for (int cnt = 0; cnt <= 7; cnt ++)
		if (cnt <= 3)
			DiiSet8255Config (hDevice, cnt, 0x80);
		else
			DiiSet8255Config (hDevice, cnt, 0x9b);

    // 
    // loopback operations
    // 
	for (grp = 0; grp < 4; grp++)
	{
		ofs = grp * 3;
		for (i = 0; i < 24; i++)
		{
			x =  (unsigned long)1 << i;
			x1 = (unsigned char)(x & 0x00ff);
			x2 = (unsigned char)((x >> 8) & 0x00ff);
			x3 = (unsigned char)((x >> 16) & 0x00ff);
			DiiSetDigitalByte (hDevice, ofs + 0, x1);
			DiiSetDigitalByte (hDevice, ofs + 1, x2);
			DiiSetDigitalByte (hDevice, ofs + 2, x3);

			mydelay();

			DiiGetDigitalByte (hDevice, ((grp + 4) * 3) + 0, &y1);
			DiiGetDigitalByte (hDevice, ((grp + 4) * 3) + 1, &y2);
			DiiGetDigitalByte (hDevice, ((grp + 4) * 3) + 2, &y3);

			str.Format("Loop: %3d  Testing Pin:%1d:%2d  Output: %02X%02X%02X  Input:%02X%02X%02X",
				loop + 1, grp + 1, i, x3, x2, x1, y3, y2, y1);
			m_Display.SetWindowText(str);

			if (x1 != y1 || x2 != y2 || x3 != y3) 
				m_Status.SetWindowText("Test Result : Error");
			else 
				m_Status.SetWindowText("Test Result : OK");

		}// end of for (i = 0; i < 24; i++)
	}// end of for (grp = 0; grp < 4; grp++)

	loop++;
	if(loop > 1000)
		loop = 0;
}

void CTestDeviceLibDlg::OnButton1() 
{
	m_bTest8255 = !m_bTest8255;

	if(m_bTest8255)
		m_Test8255LoopBack.SetWindowText("Stop Test Multi 8255 Loopback");
	else
		m_Test8255LoopBack.SetWindowText("Start Test Multi 8255 Loopback");
}

void CTestDeviceLibDlg::test8254()
{
	unsigned long loop = 0L;
	unsigned long cnt00, cnt01, cnt02, cnt10, cnt11, cnt12;  // counter value

	CString str;

  	//
	// initialization (for first time)
	//
	if(!bInitial)
	{
		DiiSetTimerConfig (hDevice, 0, 0x34);  // counter 0-0: Mode 2, LSB + MSB
		DiiLoadTimer (hDevice, 0, 1000);

		DiiSetTimerConfig (hDevice, 1, 0x74);  // counter 0-1: Mode 2, LSB + MSB
		DiiLoadTimer (hDevice, 1, 1000);

		DiiSetTimerConfig (hDevice, 2, 0xb4);  // counter 0-2: Mode 2, LSB + MSB
		DiiLoadTimer (hDevice, 2, 1000);

		DiiSetTimerConfig (hDevice, 3, 0x34);  // counter 1-0: Mode 2, LSB + MSB
		DiiLoadTimer (hDevice, 3, 1000);

		DiiSetTimerConfig (hDevice, 4, 0x74);  // counter 1-1: Mode 2, LSB + MSB
		DiiLoadTimer (hDevice, 4, 1000);

		DiiSetTimerConfig (hDevice, 5, 0xb4);  // counter 1-2: Mode 2, LSB + MSB
		DiiLoadTimer (hDevice, 5, 1000);

		bInitial = TRUE;
	}

	//
	// get counter value
	//
	DiiGetTimer (hDevice, 0, &cnt00);
	DiiGetTimer (hDevice, 1, &cnt01);
	DiiGetTimer (hDevice, 2, &cnt02);
	DiiGetTimer (hDevice, 3, &cnt10);
	DiiGetTimer (hDevice, 4, &cnt11);
	DiiGetTimer (hDevice, 5, &cnt12);

    str.Format("Loop: %8ld : counter: %6u %6u %6u %6u %6u %6u",
	     loop, cnt00, cnt01, cnt02, cnt10, cnt11, cnt12);
    m_Display8254.SetWindowText(str);
	
	loop++;
	if(loop > 1000)
		loop = 0;
}

void CTestDeviceLibDlg::OnButton4() 
{
	m_bTest8254 = !m_bTest8254;

	if(m_bTest8254)
		m_Test8254.SetWindowText("Stop Test 8254 Loopback");
	else
		m_Test8254.SetWindowText("Start Test 8254 Loopback");
}

void CTestDeviceLibDlg::OnTimer(UINT nIDEvent) 
{
	if(m_bTest8255)
		test8255loopback();

	if(m_bTest8254)
		test8254();
	
	CDialog::OnTimer(nIDEvent);
}

void CTestDeviceLibDlg::OnOK() 
{
	KillTimer(m_nTimer);   
    DiiCloseDevice(hDevice);
	CDialog::OnOK();
}

void CTestDeviceLibDlg::OnCancel() 
{
	KillTimer(m_nTimer);   
    DiiCloseDevice(hDevice);
	CDialog::OnCancel();
}

